// Includes the Servo library

#define START_ANGLE 15
#define MAX_ANGLE 16
#define SOUND_SPEED 0.017
#include <Servo.h>
// Define the pins for the HC-SR04 ultrasonic sensor
const int Trigger = 10;
const int Echo = 11;

long duration;
int distance;
Servo MG90S; 
void setup() {
  pinMode(Trigger, OUTPUT); // Set the Trigg as OUTPUT
  pinMode(Echo, INPUT); // Sets the echoPin as an INPUT
  Serial.begin(9600);
  MG90S.attach(12); // Define the pin which the MG90S servo is attached to
}
void loop() {
  // rotates the servo in a range of [15,165] degrees
  for(int i = START_ANGLE; i <= MAX_ANGLE; i++){  
  MG90S.write(i);
  delay(30);
  distance = calculateDistance();// Calls a function for calculating the distance measured by the Ultrasonic sensor for each degree
  // Using the Serial library in Processing API we can communicate on port COM3
  Serial.print(i); // Sends the current degree into the Serial Port
  Serial.print(","); // Sends addition character right next to the previous value needed later in the Processing IDE for indexing
  Serial.print(distance); // Sends the distance value into the Serial Port
  Serial.print('.'); // Sends addition character right  next to the previous value needed later in the Processing IDE for indexing
  }
}
/* We calculate the distance knowning that speed of sound is
   314 m/s and our sensor start counting the returning sound wave
   since the first has left, hence the coefficient 0.017(343 / 10 ** 4 / 2 )
   10 ** 4 because we want in centimeters*/
int calculateDistance(){ 
  
  digitalWrite(Trigger, LOW); 
  delayMicroseconds(2);
  // Sets the trigPin on HIGH state for 10 micro seconds
  digitalWrite(Trigger, HIGH); 
  delayMicroseconds(10);
  digitalWrite(Trigger, LOW);
  duration = pulseIn(Echo, HIGH); // Reads the echoPin, returns the sound wave travel time in microseconds
  distance = duration * SOUND_SPEED;
  return distance;
}
